

function namespace(namespaceString) {
    var parts = namespaceString.split('.'),
        parent = window,
        currentPart = '';    

    for(var i = 0, length = parts.length; i < length; i++) {
        currentPart = parts[i];
        parent[currentPart] = parent[currentPart] || {};
        parent = parent[currentPart];
    }

    return parent;
}

var validate = namespace('tt.util');

validate.confirmUnAssign = function(team_name){
	return (confirm("Are you sure you want to unassign the task for" + team_name + "?"));
}

validate.isValidEmail = function(email) {
	if(email.indexOf("@") < 0){
		return false;
	}if(email.indexOf("\.") < 0){
		return false;
	}else{
		var sub_text = email.split("@");
		var prefix = sub_text[0];
		if(prefix == ''){
	    	return false;
		}
		var suffix = sub_text[sub_text.length -1];
		if(suffix == ''){
			return false;
		}else if((suffix.indexOf("\.") <= 0)  || (suffix.indexOf("\.") == (email.length -1))){
			return false;
		}
	}
	return true;
}


var validName = /^([a-z0-9A-Z])*$/;
var validNumber = /^([0-9])*$/;



validate.confirmDelete = function(str) {
	return (confirm("Are you sure you want to delete selected " + str + "?"));
}


 validate.confirmReset = function() {
	return (confirm("Do you want to reset password for selected user?"));
}

validate.validateSigninForm = function(form){
if (form.signin_id.value == '') {
		alert ('Please enter a valid user name or email id! ');
		return false;
	}
	if (form.password.value == '') {
		alert ('Please enter the password!');
		return false;
	}
	return true;
};


validate.validateAndSubmitProject = function(form,img_path) {	
	if (form.name.value == 0) {
		alert ('Project title can not be blank!');
		return false;
	}
	if (form.project_description.value == 0) {
		alert ('Project description can not be blank!');
		return false;
	}	
	if (confirm("Do you want to proceed with submission?")) {
		document.getElementById('project_upload_message').innerHTML='<p> Please do not  close the browser until the attachment is completely uploaded</p><p>Loading, please wait...</p><img src="'+img_path+'" alt="'+img_path+'" />';
		return true;
	}
	return false;
}


validate.validateAndSubmitTask = function(form,img_path) {	
	if (form.name.value == 0) {
		alert ('Task title can not be blank!');
		return false;
	}
	if (form.task_description.value == 0) {
		alert ('Task description can not be blank!');
		return false;
	}	
	
	if (confirm("Do you want to proceed with submission?")) {
		document.getElementById('task_upload_message').innerHTML='<p> Please do not  close the browser until the attachment is completely uploaded</p><p>Loading, please wait...</p><img src="'+img_path+'" alt="'+img_path+'" />';
		return true;
	}
	
	return false;
}


validate.validateProjectDescription = function(form,img_path) {	
	var description = document.getElementById('description').value;
	if (description == '') {
		alert ('Please enter description.');
		tt.util.showBlock('desc_block');
		return false;
	}	
	if (confirm("Do you want to proceed with submission?")) {
		var msg_div = document.getElementById('validate_project_upload_message');
		if(msg_div) {
			msg_div.innerHTML='<p> Please do not  close the browser until the attachment is completely uploaded</p><p>Loading, please wait...</p><img src="'+img_path+'" alt="'+img_path+'" />';
		}
		
		return true;
	}
	return false;	
}


validate.validateTaskComments = function(form,img_path) {
	var comments = document.getElementById('comments').value;
	var file = document.getElementById('uploadedfile_1').value;	
	if (file == '' && comments == '' )
	{	
		alert('Please either attach any attachment or enter any comment');
		return false;
	}
	
	if (confirm("Do you want to proceed with submission?")) {
		document.getElementById('validate_task_upload_message').innerHTML='<p> Please do not close the browser until the attachment is completely uploaded</p><p>Loading, please wait...</p><img src="'+img_path+'" alt="'+img_path+'" />';
		return true;
	}
	return false;	
}

validate.validateRegistrationInputs  = function(form) {	
	if (form.email.value == '') {
		alert ('Please enter a valid email address!');
		return false;
	}
	if (!validate.isValidEmail(form.email.value)) {
		alert ('Email address not in correct format!');
		return false;
	}
	if (form.first_name.value == '') {
		alert ('First Name can not be blank!');
		return false;
	}
	if (!validName.test(form.first_name.value)) {
		alert ('First name should have alpha-numeric characters only!');
		return false;
	}
	if (form.signin_id.value == '') {
		alert ('Login Name can not be blank!');
		return false;
	}
	if (!validName.test(form.signin_id.value)) {
		alert ('Login name should have alpha-numeric characters only!');
		return false;
	}
	if (form.signin_id.value.length < 3) {
		alert ('Login name field must be at least 3 characters in length!');
		return false;
	}
	if (form.password.value == '') {
		alert ('Please enter a valid password!');
		return false;
	}
	if (form.password.value.length < 5) {
		alert ('Password field must be at least 5 characters in length!');
		return false;
	}
	if (form.password.value !== form.password_repeat.value) {
		alert ('Passwords do not match, please try again!');
		return false;
	}
	return true;
}

validate.validateEmailInputs = function(form) {
	if (form.email.value == '') {
		alert ('Please enter a valid email address!');
		return false;
	}
	if (!validate.isValidEmail(form.email.value)) {
		alert ('Email address not in correct format!');
		return false;
	}
	return true;
}

validate.validatePasswordInputs = function(form) {
	if (form.password_old.value == '') {
		alert ('Please enter a valid current password!');
		return false;
	}
	if (form.password_new.value == '') {
		alert ('Please enter a valid new password!');
		return false;
	}
	
	if (form.password_new.value.length < 5) {
		alert ('New password must be at least 5 characters in length!');
		return false;
	}
	if (form.password_new.value !== form.password_new_repeat.value) {
		alert ('New passwords do not match, please try again!');
		return false;
	}	
	return true;
}

validate.validateProfileInputs = function(form) {
	if (form.email.value == '') {
		alert ('Please enter a valid email address!');
		return false;
	}
	if (!validate.isValidEmail(form.email.value)) {
		alert ('Email address not in correct format!');
		return false;
	}
	if (form.first_name.value == '') {
		alert ('First Name can not be blank!');
		return false;
	}
	if (!validName.test(form.first_name.value)) {
		alert ('First name should have alpha-numeric characters only!');
		return false;
	}
	if (form.signin_id !== undefined  && form.signin_id !== null && form.signin_id.value == '') {
		alert ('Login name field can not be blank!');
		return false;
	}
	if (!validName.test(form.signin_id.value)) {
		alert ('Login name should have alpha-numeric characters only!');
		return false;
	}
	if (form.signin_id.value.length < 3) {
		alert ('Login name field must be at least 3 characters in length!');
		return false;
	}
	return true;
}

validate.showProfileDetails = function(objectId){
	var profile_tab = document.getElementById('profile_tab');
	var password_tab = document.getElementById('password_tab');
			
	if(objectId == 'change_password')
		{
			document.getElementById('user_profile').style.display='none';
			document.getElementById('change_password').style.display='block';
			profile_tab.style.background='none';
			profile_tab.style.color='#333333';
			password_tab.style.background='#666666';
			password_tab.style.color='#ffffff';
			
			return;
		}
		if(objectId == 'user_profile')
		{
			document.getElementById('change_password').style.display='none';
			document.getElementById('user_profile').style.display='block';
			password_tab.style.background='none';
			password_tab.style.color='#333333';
			profile_tab.style.background='#666666';
			profile_tab.style.color='#ffffff';
			
			return;
		}
		return true;		
}

validate.setToMessageUserId = function(target_user_id) {
	
	var active_users =  document.getElementById('active_users');
	if (active_users !== null && active_users !== undefined) {
		for (var i = 0; i < active_users.options.length; i++) {
			if (active_users.options[i].value == target_user_id ) {
				active_users.options[i].selected  = true;
			}
			else {
				active_users.options[i].selected  = false;
			}
		}
	}	
	var comments = document.getElementById("comments"); 
	comments.focus(); 
}

var hide='none';
var show='block';
validate.showAssignBlock =function (objectId)
{  
	var object=document.getElementById(objectId);	
	if(object.style.display==hide)
	{
		object.style.display=show;
	}
	else
	{
		object.style.display=hide;
	}
	return;
}

validate.validateUserSettingsValues = function(form) {	
	if (form.users_table_max_rows.value.length == '' || form.users_table_max_rows.value <=0 || !validNumber.test(form.users_table_max_rows.value)) {
		alert ('Please insert valid number for users per page');
		return false;
	}
	if (form.projects_per_page.value == '' || form.projects_per_page.value <=0 || !validNumber.test(form.projects_per_page.value)) {
		alert ('Please insert valid number for projects per page');
		return false;
	}
	if (form.task_comments_per_page.value == '' || form.task_comments_per_page.value <=0 || !validNumber.test(form.task_comments_per_page.value)) {
		alert ('Please insert valid number for task comments per page');
		return false;
	}		
	if (form.max_messages_per_page.value == '' || form.max_messages_per_page.value <=0 || !TT.validNumber.test(form.max_messages_per_page.value)) {
		alert ('Please insert valid number for maximum messages per page');
		return false;
	}	
	if (form.max_dashboard_block_items.value == '' || form.max_dashboard_block_items.value <=0 || !TT.validNumber.test(form.max_dashboard_block_items.value)) {
		alert ('Please insert valid number for maximum records per block in dashboard');
		return false;
	}		
	return true;
}

validate.validateSettingsValues = function(form) {	
	if (form.from_email_address.value == '') {
		alert ('Please enter a valid from email address!');
		return false;
	}
	if (!validate.isValidEmail(form.from_email_address.value)) {
		alert ('From email address not in correct format!');
		return false;
	}
	if (form.company_name.value == '') {
		alert ('Company Name can not be blank!');
		return false;
	}
	return true;
}

var count =1;
var hide='none';
var show='block';
validate.showUploadBlock = function(objectId){
	var object=document.getElementById(objectId);
	count =count+1;
	var id= "upload_block_"+count;
	var object2 =document.getElementById(id);
	object2.style.display =show;
	if(count ==6){
		object.style.display=hide;
	}
	return true;
}

var hide='none';
var show='block';
validate.showEditBlock =function (objectId)
{  
	var object = document.getElementById(objectId);

	if(object.style.display==hide)
	{
	object.style.display=show;
	}
	return;
}

validate.validateAndSubmitProjectTitle = function(form) {	
	if (form.name.value == 0) {
		alert ('Project title can not be blank!');
		return false;
	}
	if (confirm("Do you want to proceed with submission?")) {
		return true;
	}
	return false;
}

var show='block';
validate.showDeleteIcon =function (objectId)
{ 
	var iconId = 'delete_icon_'+objectId;
	var object = document.getElementById(iconId);
	object.style.display=show;
	return;
}

validate.deleteUpload =function (objectId)
{ 
	var element_id = 'upload_input_'+objectId; 
	var delete_icon_id = objectId;
	document.getElementById(element_id).innerHTML='<input id="uploadedfile_' + objectId + '" name="uploadedfile_' + objectId + '"  type="file"' + 'onchange="tt.util.showDeleteIcon(' + delete_icon_id + ')" />';
	var iconId = 'delete_icon_'+objectId;
	var object2 = document.getElementById(iconId);
	object2.style.display='none';
	return;
}

var show='block';
var hide='none';
var arrow = 'right';
validate.morethemecolors = function (objectId,arrow_img,img_path)
{
	var object = document.getElementById(objectId);
	if(object.style.display == show){
		object.style.display = hide;
	}else if(object.style.display = hide){
		object.style.display = show;
	}
	var arrow_img_object = document.getElementById(arrow_img);
	if(arrow == 'right'){
		arrow_image = 'left';
	}
	else if(arrow == 'left'){
		arrow_image = 'right';
	}
	arrow_img_path = img_path+arrow_image+'_arrow.png';
	arrow_img_object.innerHTML = '<img src="'+arrow_img_path+'" width="7" height="9" alt="more_theme_colors" title="More Theme Colors" />';
	arrow = arrow_image;
return;		
}

validate.validateTaskComment = function(form) {
	if(form.comment.value == ''|| uploadedfile_1.value == '') {
		alert('Please select file or enter comments');
		return false;
	}
	return true;
} 

validate.validateAndSubmitCopyTask = function(form){
 	if(form.new_project_id.value == ''){
		alert('Please select destination project to which the task is to be copied! ');
		return false;
	}
	return true;
}

validate.showBlock = function(ObjectID)
{
	var thisObject = document.getElementById(ObjectID);
	thisObject.style.display = "block";
}
validate.hideBlock = function(ObjectID)
{
	var thisObject = document.getElementById(ObjectID)
	thisObject.style.display = "none";
}

validate.hide_show_block = function(objectId, title, imgpath, btneve,btnshow){
	var object=document.getElementById(objectId); 
	if(object.style.display == 'block'){
		object.style.display = 'none';
		var img_path = imgpath + 'plus_task.png';
		var id_name = objectId;
		var title_id = objectId+'_title';
		var content = '<div class="title-block closed" style="padding-left:0px;">';
		content +='<img src="'+img_path+'" width="20" height="20" '+'onclick="tt.util.hide_show_block(\''+id_name+'\', \''+title+'\', \''+imgpath+'\');"/>';
		content +='<div class="title"> '+title+' </div>';
		content += 	'<div style="clear:both;"></div>	</div>'	;
		document.getElementById(title_id).innerHTML = content;		
	}
	else if(object.style.display == 'none'){		
		object.style.display = 'block';
		var img_path = imgpath + 'minus_task.png';
		var id_name = objectId;	
		var title_id = objectId+'_title';
		var content = '<div class="title-block" style="padding-left:0px;">';
		content +='<img src="'+img_path+'" width="20" height="20" '+'onclick="tt.util.hide_show_block(\''+id_name+'\', \''+title+'\', \''+imgpath+'\');"/>';
		content +='<div class="title"> '+title+' </div>';
		content +=	'<div style="clear:both;"></div>	</div>'	;
		document.getElementById(title_id).innerHTML = content;
	}	
	return;
}

validate.searchtext = function(form) {
	if(form.search_text.value == '')
	{
		alert('Please enter keyword to search');
		return false;
	}
	if(form.search_text.value == 0) 
	{
		alert('Please enter keyword to search');
		return false;
	}
	return true;
}